import React from "react";
import ReactDOM from "react-dom";
import "antd/dist/antd.css";
import SPage from "../src/index";

const formItemProps = {
  style: {
    height: 40
  }
};
const initialData = {
  age: 18
};
const tableData: any = [];
for (let i = 0; i < 100; i++) {
  tableData.push({
    age: i,
    id: i
  });
}
let fetchListFn;
const App = () => {
  const options = {
    url: "/api",
    resetForm: true,
    innerApi({ fetchTableList }) {
      fetchListFn = fetchTableList;
    },
    filters: [
      {
        type: "RangePicker",
        label: "createTime",
        key: "ctime",
        props: {
          showTime: false
        }
      },
      {
        label: "Age",
        key: "age",
        formItemProps
      },
      {
        type: "Select",
        label: "Status",
        key: "status",
        formItemProps,
        render() {
          return new Promise(rs => {
            setTimeout(() => {
              rs({ 0: "doing", 1: "done" });
            }, 2000);
          });
        }
      }
    ],
    buttons: [
      {
        label: "GetList",
        handler() {
          return fetchListFn({ age: 10 });
        }
      }
    ],
    tableData,
    tableColumns: [
      {
        title: "Action",
        buttons: [
          {
            label: "showModal",
            modalRender(row) {
              return <p style={{ height: 100 }}>{row.age}</p>;
            }
          }
        ]
      }
    ],
    rowKey: "id",
    tableProps: {
      scroll: { x: true }
    }
  };

  return (
    <div>
      <SPage initialData={initialData} {...options}></SPage>
    </div>
  );
};

ReactDOM.render(<App></App>, document.getElementById("app"));
